(******************************************************************************
*
* edgeDetector.ml : detects edges with logical linear operators.
*
* Giulio Manzonetto, Giulio Marcon, Anna Sperotto
* <{gmanzone,gmarcon,asperott}@dsi.unive.it>
*
* 
*******************************************************************************)

module EdgeDetector = struct

open Image
open LogicalLinear
open LogicalLinearEdgeOperator

let find_edges threshold image ndirs =
    let ( sx, a, stab ) = ( 2.5, 2.0, 0.2 ) in
    let ( sy, epsilon ) = ( 1.4, 0.8 ) in
    LogicalLinear.find_edges
        ~threshold:threshold
        ( int_of_float ( ceil ( 8.0 *. ( max sx sy ) +. epsilon ) ) )
        ( LogicalLinearEdgeOperator.tangential sx a stab )
        ( LogicalLinearEdgeOperator.edge sy epsilon )
        image
        ndirs
end