(******************************************************************************
*
* gfx.ml : simple graphics output management
*
* Giulio Manzonetto, Giulio Marcon, Anna Sperotto
* <{gmanzone,gmarcon,asperott}@dsi.unive.it>
*
* 
*******************************************************************************)

open Image

module Gfx = struct

    let plot_gray value depth x y = 
        let value = value * 255 / depth in
        ( Graphics.set_color ( Graphics.rgb value value value ) ;
          Graphics.plot x y )

    let plot_image ( Image.Image ( width, height, depth, imagemap ) ) =
        let rec plot_image_r x y =
            if y = height then
                ()
            else if x = width then
                plot_image_r 0 ( y + 1 )
            else
                ( plot_gray imagemap.(y).(x) depth x ( height - y ) ;
                  plot_image_r ( x + 1 ) y )
        in
        plot_image_r 0 0

    let show_image image =
        match image with 
            | ( Image.Image ( width, height, depth, imagemap ) ) ->
                ( Graphics.open_graph (Printf.sprintf " %dx%d" width ( height + 27 ) );
                  plot_image image ;
                  (* ignore ( Graphics.wait_next_event [ Graphics.Button_down ] ) ; *)
                  Graphics.close_graph 
                )
end