(******************************************************************************
*
* mainLogLin.ml: main program for Logical Linear Edge Detector
*
* Giulio Manzonetto, Giulio Marcon, Anna Sperotto
* <{gmanzone,gmarcon,asperott}@dsi.unive.it>
*
* 
*******************************************************************************)

open Edge
open EdgeDetector
open Gfx
open Image
open Netpbm
open Ps
open Utils

;;

let ( ndirs, t, filename ) = Arghandle.loglin_get_parameters () in
let _ = Printf.printf "reading image... %!\n" in
let image = Utils.temp_resource Netpbm.load ( open_in_bin filename ) close_in in
let ( Image.Image ( width, height, depth, imagemap ) ) = image in
let _ = Gfx.show_image image in
let edges = EdgeDetector.find_edges t image ndirs in
Ps.write_file ( ( String.sub filename 0 ( ( String.length filename ) - 4 ) ) ^ "-edges.ps") edges
