(******************************************************************************
*
* math.ml : math library.
*
* Giulio Manzonetto, Giulio Marcon, Anna Sperotto
* <{gmanzone,gmarcon,asperott}@dsi.unive.it>
*
* 
*******************************************************************************)

let pi = 4.0 *. atan 1.0

let gaussian sigma x =
    exp ( -. x *. x /. ( 2.0 *. sigma *. sigma ) ) *.
    2.0 /. ( sqrt pi ) /. sigma

let dG sigma x =
    -. x *. ( gaussian sigma x ) /. ( sigma *. sigma )

let d2G sigma x =
    let sigma2 = sigma *. sigma in
    let sigma4 = sigma2 *. sigma2 in
    ( x *. x -. sigma2 ) *. ( gaussian sigma x ) /. sigma4

let d4G sigma x =
    let sigma2 = sigma *. sigma in
    let sigma4 = sigma2 *. sigma2 in
    let sigma8 = sigma4 *. sigma4 in
    ( x *. x *. ( x *. x -. 6.0 *. sigma2 ) +. 3.0 *. sigma4 ) *. gaussian sigma x /. sigma8

let round f =
    truncate ( floor ( f +. 0.5 ) )
    