(******************************************************************************
*
* progressNotifier.ml : notifies the computation progress.
*
* Giulio Manzonetto, Giulio Marcon, Anna Sperotto
* <{gmanzone,gmarcon,asperott}@dsi.unive.it>
*
* 
*******************************************************************************)

open Format

module ProgressNotifier =
struct

    let make msg ( a, b ) =
        let last_percent = ref (-1) in
        let get_user_time () = ( Unix.times () ).Unix.tms_utime in
        let start_time = ref ( get_user_time () ) in
        let progress_notifier i iteration =
            let _ = printf "\riteration: %d  %s: %!" i msg in
            let percent = ( iteration - a ) * 100 / ( b - a )
            in
            let _ = 
                if not ( percent = (!last_percent) ) then 
                    last_percent := percent 
                else 
                    ()
            in
            if ( percent >= 100 ) then
                printf "100%% %!"
            else
                printf "%d%%  \b\b%!" percent
    in
    progress_notifier

    let make_loglin msg (a, b) =
        let last_percent = ref (-1) in
        let progress_notifier i =
            let percent = ( i - a ) * 100 / ( b - a )
            in
            if percent = (!last_percent) then 
                ()
            else 
                (
                    let _ = last_percent := percent in
                    let _ = printf "\r%s: %!" msg in
                    printf "%d%%  \b\b%!" percent
                )
        in
        progress_notifier

end
